title BT2.COM : Boot disquette sur disque dur V2.00
        Page    55,120
; Pour TURBO ASM. Supprimer cette ligne pour MASM
.MODEL TINY
        Name    BT

;*********************************************;
;*                                           *;
;*                BOOTTHRU 2                 *;
;*                ----------                 *;
;*********************************************;

;******************************************************************************;
;*Ce programme permet sur une disquette de la rendre "disque dur bootable".   *;
;*C'est  dire que si on oublie la disquette dans le lecteur, on bootera      *;
;*automatiquement sur le disque dur, au lieu d'afficher                       *;
;*"This disquette is not system" ou quelque chose comme a.                   *;
;******************************************************************************;

; L'ide originale est de Daniel Gibson, mais dans la version qu'il proposait,
; cela ne marchait que sur des disquettes 360K. Cete version fonctionne sur
; tout types de disquettes existant et peut tre  venir. Elle a t galement
; mise  jour pour les disquettes DOS 4.
;
; La mise  jour a t faite par Serge Delbono qui a honteusement dsassembl
; le boot de la version de Daniel.
; Version : 2.00 du 15 juin 1990
;
; Version 2.10 du 4 juin 1991 :
; Special BBS : l'absence de disque dur relance le boot, au lieu de
; lancer le "Basic" : ainsi on peut mettre le "dplanteur systmatique"
; c a d une coupure automatique de l'alim une fois par jour : Si le
; disque a du mal  redmarrer, on rebootera tant que le disque n'est pas
; prt...

; Quelques constantes utiles et agrables

MS_DOS  EQU     21H     ; IT MS/DOS
DISK    EQU     13H     ; IT Disque

TAB     equ     09h     ; ASCII
CR      equ     0Dh     ; ASCII
LF      equ     0Ah     ; ASCII
EOM     equ     '$'     ; ASCII
ESCAPE  equ     1Bh     ; ASCII

; Quelques macros, toujours utiles et agrables

; affiche un message
disp_msg Macro msg
       Mov      ah,9
       Mov      dx,offset msg
       Int      ms_dos
       endm

; lit un car au clavier sans echo, avec vidage buffer
getchar Macro
        Mov     ax,0c08h        ;; lecture clavier apres RAZ
        Int     MS_DOS
        endm

; affiche un caractre

putchar Macro   car
        ifdef   car
        mov     dl,car
        endif
        mov     ah,2
        int     ms_dos
        endm

;***********************************************;
;*                                             *;
;*        DEBUT DU CODE DE L'EXECUTABLE        *;
;*        -----------------------------        *;
;*                                             *;
;***********************************************;

code    Segment Para Public 'CODE'
        Assume CS:CODE
        Org     100H
        Assume  Ds:code
debut:
        Push    CS
        Pop     DS
        disp_msg _hello ; bonjour !

; Lecture de la ligne de commande (le 1er car non blanc est le drive a trait)
        Mov     Si,81h  ; lig de commande
        cld
reb:
        lodsb
        cmp     al,' '
        je      reb
        cmp     al,TAB
        je      reb
        cmp     al,CR
        je      def
        cmp     al,'a'
        jb      maj
        sub     al,'a'-'A'
maj:
        sub     al,'A'
        cmp     al,25           ; 25 lettres
        ja      error
        jmp     short suit
;
; erreur de syntaxe
;
error:
        disp_msg _err
        Mov     Ax,4C01h
        int     MS_DOS

; par defaut, drive A:

def:
        mov     al,0
suit:
        mov     drv,al

encore:
        disp_msg _aff1          ; are you ready ?
        mov     al,drv          ; affiche le drive
        add     al,'A'
        putchar al
        disp_msg _aff2
        getchar
        cmp     AL,ESCAPE       ; abort ?
        je      fini
; do it !
        Mov     ah,2
        Call    read_it         ; on lit le boot
        jc      err_phy
        Mov     si,offset Start ; on ajoute JMP debutboot + notre nom
        Mov     di,offset Buffer
        cld
        Mov     cx,11
        rep     movsb
        Mov     si,offset titre ; on ajoute notre boot
        mov     di,offset buffer+(titre-start)
        mov     cx,(512-3Eh)/2
        rep     movsw
        Mov     Ah,3
        call    read_it         ; on ecrit notre boot
        jc      err_phy
        disp_msg _vabene
        jmp     encore

fini:
        mov     ax,4C00h        ; On se casse !
        int     MS_DOS
err_phy:
        disp_msg _phy           ; erreur physique : on essaie...
        jmp     encore

;*******************************************************************;
;*Malgr son nom, cette procdure lit ou crit le 1er secteur      *;
;*(c'est  dire le boot)                                           *;
;*Entre : AH=2 : lecture                                          *;
;*         Ah=3 : Ecriture                                         *;
; Sortie : CF=0 OK                                                 *;
;*******************************************************************;

read_it proc near

        mov     dl,drv
        mov     cx,7    ; on a droit  5 essais
retry:
        Push    cx
        Push    ax
        mov     ah,00   ; reset disque
        int     DISK

        pop     ax
        push    ax
        mov     cx,1
        Mov     bx,offset buffer
        push    cs
        pop     es
        clc
        mov     al,1
        mov     dh,0
        int     DISK            ; Do IT !
        jnc     ok_rd
        cmp     ah,03h
        pop     ax
        pop     cx
        je      errprot
        loop   retry
errdsk:
        stc
        ret

errprot:                        ; disquette protg, enlever le sticker !
        disp_msg _prot
        getchar
        cmp     al,ESCAPE
        je      errdsk
        jmp     read_it

ok_rd:
        pop     ax
        pop     cx
        clc
        ret
read_it endp

drv     db      0

;***************************;
;*                         *;
;*      Les Messages       *;
;*                         *;
;***************************;

_aff1   db      'Insrer la disquette dans le drive ',EOM
_aff2   db      ':',cr,lf,'et frappez une touche. ESC pour arrter.',cr,lf,EOM

_hello  db      'BootThru 2.1. Modificateur de disquette.',cr,lf
        db      'Bill Gibson 1987. Serge Delbono 1990/91',cr,lf,eom
_err    db      'Syntaxe : BT [Lettre lecteur]',cr,lf
        db      'Dfaut A:',cr,lf,EOM
_phy    db      'Erreur lecture/criture',cr,lf,EOM
_prot   db      'Disquette protge. Enlevez le sticker.',cr,lf,eom
_vabene db      'opration effectue avec succs !',cr,lf,lf,eom

;***********************************************************;
;*                 Code du boot  mettre.                  *;
;*                 ----------------------                  *;
;*On est oblig de jongler avec les offsets et tout !      *;
;*                                                         *;
;***********************************************************;

; Les spcialistes reconnaitront les commentaires et les tiquettes de Sourcer

even
start:
                jmp     do_boot                 ; 1er jump
                db      'Serge D.'              ; notre signature
; --- zone rserve ---
                org     start+3Eh

Titre           db      LF,cr,07
                db       "",lf,cr
                db       " N'oubliez pas vos disquettes dans le lecteur ! ",lf,cr
                db       "BOOTHRU 2.1 de Serge Delbono (d'aprs D.Gibson) ",lf,cr
                db       "       vous offre un Boot disque dur....        ",lf,cr
                db       "                                                ",lf,cr
                db       "",lf

                db      EOM

do_boot:
                mov     ax,7C0h         ; c'est l'adresse fixe ou on est
                mov     es,ax           ; CS vaut n'importe quoi !
                mov     ds,ax           ; ES et DS point sur le dbut du Boot
                mov     si,(Offset titre-Offset start)
                cld
loc_2:
                mov     ah,0Eh
                lodsb
                cmp     al,EOM
                je      loc_3        ; Jump if equal
                push    si
                int     10h          ; Video display   ah=functn 0Eh
                                     ;  write char al, teletype mode
                pop     si
                jmp     short loc_2
loc_3:
                cld                     ; on recopie notre code
                mov     si,(offset recopie-offset start) ; au dela du boot
                mov     di,200h         ; pour lire le code du boot DR
                mov     cx,200h/2
                rep     movsw
                jmp     Start+200h
; ce code sera boug en [START+200h]
recopie:
                mov     ds:word ptr [1FEh],0   ; On efface la signature boot
                                        ; pour ne pas se planter en cas d'erreur
                                        ; de lecture
                mov     bx,0
                mov     cx,1
                mov     dx,0080h        ; lecture disque dur 0
                mov     ax,0201h        ; face 0 piste 0 secteur 1
                int     DISK            ; Disk  dl=drive a: ah=func 02h
                                        ;  read sectors to memory es:bx
                mov     bx,1FEh
                cmp     word ptr [bx],0AA55h  ; bien lu ?
                jne     loc_4                 ; Jump if not equal
                jmp     recopie-200h          ; ca doit tre le debut du boot

loc_4:
;;     int     18h                   ; ROM basic (on boote pas)
;----  Jmp      FFFF:0
       cli
       db       0EAh
       dw       0,0FFFFh
       db      'BootThru 2.1, Copyright (c) Bill Gibson, 02.09.87.'
       db      'S.Delbono 1990/91'
       org     start+1FEh
       db      55h, 0AAh        ; signature pour le boot ROM
END_BOOT        label byte
; ----------------- FIN DU CODE DU BOOT ---------------
; On recopiera le boot original ici pour le modifier
buffer  equ     this    byte+10h
code    ends
        end     debut
